"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrossMintPopupProvider = void 0;
const react_1 = __importStar(require("react"));
const _1 = require(".");
const useCrossMintPopup_1 = require("./useCrossMintPopup");
const PROD_URL = "https://crossmint.io";
const DEV_URL = "http://localhost:3001";
const CrossMintPopupProvider = ({ development, children }) => {
    const [connecting, setConnecting] = (0, react_1.useState)(false);
    const [popup, setPopup] = (0, react_1.useState)(null);
    const { clientId } = (0, _1.useCrossMintStatus)();
    const { setVisible } = (0, _1.useCrossMintModal)();
    const createPopup = (collectionTitle, collectionDescription, collectionPhoto, mintTo, emailTo, listingId) => {
        const pop = window.open(`${development ? DEV_URL : PROD_URL}/signin?callbackUrl=${encodeURIComponent(`${development ? DEV_URL : PROD_URL}/checkout/mint?clientId=${clientId}&closeOnSuccess=false${collectionTitle && `collectionTitle=${collectionTitle}`}${collectionDescription && `&collectionDescription=${collectionDescription}`}${collectionPhoto && `&collectionPhoto=${collectionPhoto}`}${mintTo && `&mintTo=${mintTo}`}${emailTo && `&emailTo=${emailTo}`}${listingId && `&listingId=${listingId}`}`)}`, "popUpWindow", createPopupString());
        if (pop) {
            setVisible(true);
            setPopup(pop);
            registerListeners(pop);
        }
        else {
            setConnecting(false);
            console.log("Failed to open popup window");
        }
    };
    const connect = (collectionTitle, collectionDescription, collectionPhoto, mintTo, emailTo, listingId) => {
        if (connecting)
            return;
        setConnecting(true);
        createPopup(collectionTitle, collectionDescription, collectionPhoto, mintTo, emailTo, listingId);
    };
    function registerListeners(pop) {
        const timer = setInterval(function () {
            if (pop.closed) {
                clearInterval(timer);
                setConnecting(false);
                setVisible(false);
            }
        }, 500);
    }
    function createPopupString() {
        return `height=750,width=400,left=${window.innerWidth / 2 - 200},top=${window.innerHeight / 2 - 375},resizable=yes,scrollbars=yes,toolbar=yes,menubar=true,location=no,directories=no, status=yes`;
    }
    return (react_1.default.createElement(useCrossMintPopup_1.PopupContext.Provider, { value: {
            connecting,
            popup,
            connect,
        } }, children));
};
exports.CrossMintPopupProvider = CrossMintPopupProvider;
//# sourceMappingURL=CrossMintPopupProvider.js.map